SWP_NOSIZE                           equ 1h
SWP_NOMOVE                           equ 2h
SWP_NOZORDER                         equ 4h
SWP_NOREDRAW                         equ 8h
SWP_NOACTIVATE                       equ 10h
SWP_FRAMECHANGED                     equ 20h
SWP_SHOWWINDOW                       equ 40h
SWP_HIDEWINDOW                       equ 80h
SWP_NOCOPYBITS                       equ 100h
SWP_NOOWNERZORDER                    equ 200h
SWP_DRAWFRAME                        equ SWP_FRAMECHANGED
SWP_NOREPOSITION                     equ SWP_NOOWNERZORDER
SWP_DEFERERASE                                equ 2000h
SWP_ASYNCWINDOWPOS                            equ 4000h

GWL_WNDPROC	  = -4
GWL_HINSTANCE	  = -6
GWL_HWNDPARENT	  = -8
GWL_STYLE	  = -16
GWL_EXSTYLE	  = -20
GWL_USERDATA	  = -21
GWL_ID		  = -12
DWL_MSGRESULT	  = 0
DWL_DLGPROC	  = 4
DWL_USER	  = 8

BST_CHECKED	  = 1
BST_UNCHECKED	  = 0
BM_GETCHECK = 00F0h
BM_SETCHECK = 00F1h

WM_INITDIALOG		equ	110h
WM_CLOSE		equ	10h
WM_COMMAND		equ	111h
WM_CHAR			equ	102h

WS_BORDER equ 800000h
WS_EX_CLIENTEDGE                     equ 00000200h
WS_EX_STATICEDGE                     equ 00020000h

;EN_CHANGE  
;idEditCtrl = (int) LOWORD(wParam); // identifier of edit control 
;hwndEditCtrl = (HWND) lParam;      // handle of edit control 
EN_CHANGE equ 768
EN_UPDATE equ 400h

WM_SETTEXT		equ	12
WM_GETTEXT equ 13
WM_GETTEXTLENGTH equ 14

WM_SETICON equ 80h
RECT	struc
	l	dd	?
	t	dd	?
	r	dd	?
	b	dd	?
RECT	ends

;---------------------------------------------include DEFS32.INC
	includelib	import32.lib
	extrn	ExitProcess:proc
	extrn	GetModuleHandleA:proc
	extrn	SendMessageA:proc
	extrn	lstrlenA:proc
	extrn	DialogBoxParamA:proc
;	extrn	EndDialog:proc
	extrn	GetDlgItem:proc
;	extrn	GetDlgItemInt:proc
;	extrn	SetDlgItemInt:proc

	extrn	GetFocus:proc
	extrn	SetFocus:proc

	extrn	GlobalAlloc:near
	extrn	GlobalFree:near

;	extrn	wsprintfA:proc

	extrn GetWindowRect:proc
	extrn SetWindowPos:proc
	extrn GetDesktopWindow:proc
	extrn LoadIconA:proc
	
	extrn GetWindowLongA:proc
	extrn SetWindowLongA:proc
	extrn SetWindowPos:proc
;---------------------------------------------include APICALLS.INC


	.386
	.model flat,stdcall

	.data?
dtr RECT<?,?,?,?>
dlr RECT<?,?,?,?>

hinst dd ?
ctrl dd ?
result dd ?
buf db	1024 dup(?)
	.data
;ww: dd 0
signf dd 0
iserr dd 0
	.code
_start:
	xor	ebx,ebx
	call	GetModuleHandleA,ebx
	mov hinst,eax
	call	DialogBoxParamA,eax,300,ebx,offset dialog_proc,ebx
;	cmp	eax,0ffffffffh;?
;	jz	failure

failure:
	call	ExitProcess,ebx

dialog_proc	proc	near
	push	ebp
	mov	ebp,esp
dp_hWnd		equ	dword ptr [ebp+08h] ; DIALOG_id
dp_uMsg		equ	dword ptr [ebp+0Ch] ; message #
dp_wParam	equ	dword ptr [ebp+10h] ; 1st param.
dp_lParam	equ	dword ptr [ebp+14h] ; 2nd param.

	mov	ecx,dp_hWnd
	mov	eax,dp_uMsg
;	mov	hwnd_dlg,ecx
	cmp	eax,WM_INITDIALOG
	jne	not_initdialog
;initialisation dialogs
	call GetDesktopWindow
	call GetWindowRect,eax,offset dtr
	call GetWindowRect,dp_hWnd,offset dlr
;SetWindowPos( hDlgWnd, HWND_TOP, (DesktopRect.right - DialogRect.right) / 2
;,(DesktopRect.bottom - DialogRect.bottom) / 2,0,0, SWP_NOSIZE );
;SetWindowPos(hWnd,hWndInsertAfter,X,Y,cx,cy,uFlags);
	mov eax,dtr.r
	sub eax,dlr.r
	shr eax,1
	mov ecx,dtr.b
	sub ecx,dlr.b
	shr ecx,1

HWND_TOPMOST   = -1
HWND_TOP equ 0
SWP_NOSIZE equ 1
;SetWindowPos(hwnd01, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
	call SetWindowPos,dp_hWnd,HWND_TOPMOST,eax,ecx,0,0,SWP_NOSIZE
;SendMessage(hDlgWnd, WM_SETICON, ICON_SMALL, (LPARAM)LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON)));
ICON_SMALL equ 0
;LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON)))
	call LoadIconA,hinst,299
	call SendMessageA,dp_hWnd,WM_SETICON, ICON_SMALL,eax

	cmp word ptr signf,0
	je noscheck
	call GetDlgItem,dp_hWnd,305
	call SendMessageA,eax,BM_SETCHECK,BST_CHECKED,ebx
noscheck:

;	call GetDlgItem,dp_hWnd,301
;	push eax
;	call GetWindowLongA,eax,GWL_STYLE
;	mov edx,WS_BORDER
;	xor edx,0FFFFFFFFh
;	and eax,edx
;	pop ecx
;	call SetWindowLongA,ecx,GWL_STYLE,eax
;
	call mk_flat

	jmp	not_exit
not_initdialog:
	cmp	eax,WM_CLOSE
	jne	not_close

close_dlg:
	jmp failure;;call	EndDialog,ecx,0
not_close:
	cmp	eax,WM_COMMAND
	jne	not_command
	
	call GetFocus
	mov edx,eax

	mov	eax,dp_wParam
	cmp	eax,2
	je	close_dlg
	cmp ax,305
	jne not_ch_box
	call GetDlgItem,dp_hWnd,305
	call SendMessageA,eax,BM_GETCHECK,ebx,ebx
	mov signf,eax
;	SendMessage (hwndCheck, BM_GETCHECK, 0, 0)
	jmp	not_exit
not_ch_box:
	mov ecx,eax
	and ecx,00000FFFFFh
	shr	eax,10h
	cmp	eax,EN_CHANGE;EN_UPDATE
	jne not_field

	call getid
	je process_field

not_field:
	jmp	not_exit
process_field:
 push edi
 push esi
 push ebx
GMEM_FIXED equ 0h
GMEM_ZEROINIT equ 40h

	mov ctrl,ecx

	mov result,ebx;ebx=0
	mov iserr,ebx

	call GetDlgItem,dp_hWnd,ecx
;	call GetFocus
	mov ebx,eax
	call SendMessageA,ebx,WM_GETTEXTLENGTH,0,0
	or eax,eax
	je endcon
	inc eax
	push eax
	call	GlobalAlloc,GMEM_FIXED+GMEM_ZEROINIT,eax;flags+size
    mov edi,eax
    pop eax
	call SendMessageA,ebx,WM_GETTEXT,eax,edi;cchtextMax ,lpsztext
	mov eax,ctrl
	cmp eax,301
	jne bra1
	call con10
	call put02
	call put08
	call put16
	call setchar
	xor eax,eax
bra1:
	cmp eax,302
	jne bra2
	call con16
	call put02
	call put08
	call put10
;	call put16
	call setchar
	xor eax,eax
bra2:
	cmp eax,303
	jne bra3
	call con02
;	call put02
	call put08
	call put10
	call put16
	call setchar
	xor eax,eax
bra3:
	cmp eax,304
	jne bra4
	call con08
	call put02
;	call put08
	call put10
	call put16
	call setchar
	xor eax,eax
bra4:
	cmp eax,306
	jne bra5

	call GetDlgItem,dp_hWnd,306
	call SendMessageA,eax,WM_GETTEXT,2,offset buf
	mov eax,dword ptr buf
	and eax,255
	mov result,eax
	call GetDlgItem,dp_hWnd,301
	call SetFocus,eax
	call put10
	call GetDlgItem,dp_hWnd,306
	call SetFocus,eax

bra5:
	call GlobalFree,edi
;convert all systems if no error
	cmp dword ptr iserr,0
	je no_err
;reset except typed values
	mov eax,301
resva:
	push eax
	call GetDlgItem,dp_hWnd,eax
	push eax
	call GetFocus
	pop ecx
	cmp eax,ecx
	je resavanxt
	call SendMessageA,ecx,WM_SETTEXT,0,0
resavanxt:
	pop eax
	inc eax
	cmp eax,305
	jne resva
	jmp short endcon
no_err:
;	call convbase
endcon:
	pop ebx
	pop esi
	pop edi
not_exit:
	xor	eax,eax
	inc	eax
	leave
	ret	16
not_command:
	xor	eax,eax
	leave
	ret	16
dialog_proc	endp

setchar:
	mov eax,result
	and eax,255
	mov dword ptr buf,eax

	call GetDlgItem,dp_hWnd,306
	call SendMessageA,eax,WM_SETTEXT,0,offset buf
	ret

con10:
	mov esi,edi
	call lstrlenA,esi
	mov	ecx,eax
	xor edx,edx
	cmp dword ptr signf,0
	je c10l
	cmp byte ptr [esi],"-"
	jne c10l
	inc esi
	dec ecx
	je e10f
c10l:
	xor eax,eax
	cld
	lodsb
	sub eax,48
	js e10f
	cmp eax,10
	jle no10e
e10f:
	mov dword ptr iserr,1
	jmp short c10e
no10e:
	mov ebx,edx
	add edx,edx
	jc e10f
	add edx,edx
	jc e10f
	add edx,ebx
	jc e10f
	add edx,edx
	jc e10f
	add edx,eax
	jc e10f
	loop	c10l
	cmp dword ptr signf,0
	je c10ee
	cmp byte ptr [edi],"-"
	jne c10ee
	call signedx;neg edx
c10ee:
	mov result,edx
c10e:
	ret
signedx:
	cmp edx,000000FFh
	jge se1
	xor edx,000000FFh
	inc edx
	ret
se1:
	cmp edx,0000FFFFh
	jge se2
	xor edx,0000FFFFh
	inc edx
	ret
se2:
	neg edx
	ret

con16:; proc	near
;	push eax
	mov esi,edi
	call lstrlenA,esi
	mov	ecx,eax; 32bit - len>8 error
	xor edx,edx
	cld
c16l:
	xor eax,eax
	lodsb
	sub	eax,48
	js e16f
	cmp eax,22 ; 'F'-'0'
	jg e16f
	cmp eax,9; 0-9
	jle c16n
	cmp eax,17
	jge c16a
e16f:
	mov dword ptr iserr,1
	jmp short c16e
c16a:
	sub eax,7
c16n:
;	shl edx,4
	add edx,edx
	jc e16f
	add edx,edx
	jc e16f
	add edx,edx
	jc e16f
	add edx,edx
	jc e16f
	add edx,eax
	jc e16f

	loop c16l
c16e:
	mov result,edx
;	pop eax
	ret

;con16 endp

con02:; proc	near
;	push eax
	mov esi,edi
	call lstrlenA,esi
	mov	ecx,eax; 32bit - len>8 error
	xor edx,edx
	cld
c02l:
	xor eax,eax
	lodsb
	cmp eax,48
	je c02n
	cmp eax,49
	je c02n
c02f:
	mov dword ptr iserr,1
	jmp short c02e
c02n:
	sub eax,48
	add edx,edx
	jc c02f
	add edx,eax
	jc c02f
	loop c02l
c02e:
	mov result,edx
;	pop eax
	ret
;con02 endp

con08:; proc	near
;	push eax
	mov esi,edi
	call lstrlenA,esi
	mov	ecx,eax
	xor edx,edx
	cld
c08l:
	xor eax,eax
	lodsb
	sub eax,48
	js c08f
	cmp eax,7
	jng c08n
c08f:
	mov dword ptr iserr,1
	jmp short c08e
c08n:
	add edx,edx
	jc c08f
	add edx,edx
	jc c08f
	add edx,edx
	jc c08f
	add edx,eax
	jc c08f
	loop c08l
c08e:
	mov result,edx
;	pop eax
	ret
;con08 endp

revbuf:; proc
;	push esi
	lea edi,buf
	mov esi,edi
	call lstrlenA,edi
	cmp eax,2
	jl ex_re
	add esi,eax
	dec esi
	mov ecx,eax
	shr ecx,1
relp:
	mov al,byte ptr [edi]
	mov ah,byte ptr [esi]
	mov byte ptr [edi],ah
	mov byte ptr [esi],al

	inc edi
	dec esi
	loop relp
ex_re:
;	pop esi
	ret
;revbuf endp

;detctrl:
;	call GetFocus
;	push eax
;	call GetDlgItem,dp_hWnd,ebx
;	pop ecx
;
;	lea edi,buf
;
;	cmp eax,ecx
;	ret

;decimals
put10:
	push edi
	lea edi,buf
	mov ebx,301
	mov eax,result
	cmp dword ptr signf,0
	je cont10
	test eax,80000000h
	je p10_1
	xor eax,0FFFFFFFFh
	inc eax
p10_1:
	test eax,00008000h
	je p10_2
	xor eax,0000FFFFh
	inc eax
p10_2:
	test eax,00000080h
	je cont10
	xor eax,000000FFh
	inc eax
cont10:
	mov ecx,10
	cld
c_10:
	xor edx,edx;cdq
	div ecx ; eax=rest, edx=remainder
	add edx, 48
	mov byte ptr [edi],dl
	inc edi
	or eax,eax
	jne c_10
;"-"
	mov eax,result
	cmp dword ptr signf,0
	je p10_5
	test eax,80000000h
	jne p10_6
	test eax,00008000h
	jne p10_6
	test eax,00000080h
	je p10_5
p10_6:
	mov al,"-"
	stosb
p10_5:
	xor eax,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	call set1
	pop edi
	ret

;binary
put02:
	push edi
	mov ebx,303
	lea edi,buf
	mov eax,result
	cld
c_2:
	push eax
	and eax,1
	add eax,48
	stosb
	pop eax
	shr eax,1
	or eax,eax
	jne c_2
	call set1
	pop edi
	ret

;hexdec
put16:

	push edi
	lea edi,buf
	mov ebx,302

	mov eax,result
	cld
c_16:
	push eax
;h1$(a)=chr$( 48+a+7*(a>9) )
	and eax,15
	cmp eax,10
	jl hexbra
	add eax,7
hexbra:
	add eax,48
	stosb
	pop eax
	shr eax,4
	or eax,eax
	jne c_16
	call set1
	pop edi
	ret

;octals
put08:
	push edi
	lea edi,buf
	mov ebx,304

	mov eax,result
	cld
c_8:
	push eax
	and eax,7
	add eax,48
	stosb
	pop eax
	shr eax,3
	or eax,eax
	jne c_8
	call set1
	pop edi
	ret

set1:
	stosb
	call revbuf
	call GetDlgItem,dp_hWnd,ebx
	call SendMessageA,eax,WM_SETTEXT,0,offset buf
go_end:
	ret
getid:
	push ecx
	push edx
	call GetDlgItem,dp_hWnd,ecx
	pop edx
	pop ecx
	cmp eax,edx
	ret

mk_flat:
	push ebx
	mov eax,301
mkfl:
	push eax
	call GetDlgItem,dp_hWnd,eax
	mov ebx,eax
	call GetWindowLongA,ebx,GWL_EXSTYLE
	and eax, 0-WS_EX_CLIENTEDGE
	or eax, WS_EX_STATICEDGE
	call SetWindowLongA,ebx,GWL_EXSTYLE,eax
	call	SetWindowPos, ebx, 0, 0, 0, 0, 0, SWP_NOACTIVATE + SWP_NOZORDER + SWP_FRAMECHANGED + SWP_NOSIZE + SWP_NOMOVE + SWP_DRAWFRAME
	pop eax
	inc eax
	cmp eax,307
	jne mkfl
	pop ebx
	ret
end	_start
